#ifndef _IPT_LOG_H
#define _IPT_LOG_H

#ifndef CONFIG_ARCH_NG_FVS336GV2
#define CONFIG_ARCH_NG_FVS336GV2
#endif

/* make sure not to change this without changing netfilter.h:NF_LOG_* (!) */
#define IPT_LOG_TCPSEQ		0x01	/* Log TCP sequence numbers */
#define IPT_LOG_TCPOPT		0x02	/* Log TCP options */
#define IPT_LOG_IPOPT		0x04	/* Log IP options */
#define IPT_LOG_UID			0x08	/* Log UID owning local socket */
#define IPT_LOG_NFLOG		0x10	/* Log using nf_log backend */
#define IPT_LOG_MASK		0x1f

#define IPT_LOG_UNICAST            1
#define IPT_LOG_BCAST_MCAST        2
#define IPT_LOG_UCAST_BCAST_MCAST  3
#define IPT_LOG_NO_PKT             0

struct ipt_log_info {
	unsigned char level;
	unsigned char logflags;
	char prefix[40];
	char format[256];
};

struct sk_buff;

void dump_packet_wrapper(const struct ipt_log_info *,
			const struct sk_buff *, unsigned int);

#endif /*_IPT_LOG_H*/
